import { BehaviorSubject, of } from 'rxjs';
import { switchMap } from 'rxjs/operators';
import { CommonModule } from '@angular/common';
import { ActivatedRoute, RouterModule } from '@angular/router';
import { Injectable, ChangeDetectionStrategy, Component, Input, NgModule, CUSTOM_ELEMENTS_SCHEMA, Inject, ChangeDetectorRef, Optional, InjectionToken, defineInjectable } from '@angular/core';
import { Title, DomSanitizer } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DocsService = /** @class */ (function () {
    function DocsService() {
        this._menuItems$ = new BehaviorSubject(null);
    }
    Object.defineProperty(DocsService.prototype, "menuItems$", {
        get: /**
         * @return {?}
         */
        function () {
            return this._menuItems$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocsService.prototype, "menuItems", {
        set: /**
         * @param {?} items
         * @return {?}
         */
        function (items) {
            this._menuItems = items;
            this._menuItems$.next(items);
        },
        enumerable: true,
        configurable: true
    });
    DocsService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ DocsService.ngInjectableDef = defineInjectable({ factory: function DocsService_Factory() { return new DocsService(); }, token: DocsService, providedIn: "root" });
    return DocsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var baseTitle = function (title) {
    return title.includes('|') ? title.split(' | ')[0] : title;
};
/** @type {?} */
var titleFromName = function (name) {
    return name.split(/(?=[A-Z])/).join(' ');
};
/** @type {?} */
var titleFromTag = function (tag) {
    return tag.split('-').slice(1).map(function (word) { return word.charAt(0).toUpperCase() + word.slice(1); }).join(' ');
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ApiComponent = /** @class */ (function () {
    function ApiComponent(title, service) {
        this.title = title;
        this.service = service;
        this.service.menuItems = undefined;
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | API");
    }
    ApiComponent.decorators = [
        { type: Component, args: [{
                    template: '<router-outlet></router-outlet>',
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    ApiComponent.ctorParameters = function () { return [
        { type: Title },
        { type: DocsService }
    ]; };
    return ApiComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var FrameworkType = {
    angular: 'angular',
    javascript: 'javascript',
};
/** @type {?} */
var DEMO_COMPONENTS = new InjectionToken('Demo components');
/** @type {?} */
var GET_STARTED_URL = new InjectionToken('URL to get started from home');
/** @type {?} */
var HOME_README = new InjectionToken('Injectable Home Readme');
/** @type {?} */
var LIBRARY_API = new InjectionToken('The full library API');
/** @type {?} */
var MODULE_DOCS = new InjectionToken('Demo components');
/** @type {?} */
var MODULE_GET_STARTED_URL = new InjectionToken('URL to try a module');
/** @type {?} */
var MODULE_NAME = new InjectionToken('Module name');
/** @type {?} */
var MODULE_README = new InjectionToken('Injectable Web Components Readme');
/** @type {?} */
var MODULE_TYPE = new InjectionToken('The framework the module is for');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ApiDocComponent = /** @class */ (function () {
    function ApiDocComponent(title, route, api) {
        var _this = this;
        this.title = title;
        this.route = route;
        /** @type {?} */
        var module = this.route.snapshot.paramMap.get('module');
        this.id = this.route.snapshot.paramMap.get('id');
        this.doc = api[module].find(function (d) { return d.tag ? d.tag === _this.id : d.name === _this.id; });
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + this.id);
    }
    ApiDocComponent.decorators = [
        { type: Component, args: [{
                    template: "<article class=\"component-readme\">\n    <div class=\"breadcrumbs\">\n        <a [routerLink]=\"['../../']\">API</a><span class=\"sep\">/</span><span class=\"id\">{{id}}</span>\n    </div>\n    <ad-markdown [data]=\"doc.readme\"></ad-markdown>\n    <ad-api [doc]=\"doc\"></ad-api>\n</article>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:block}:host .breadcrumbs{margin-bottom:1rem}:host .breadcrumbs .sep{color:var(--anj-border-dark);margin:0 .5rem}:host .breadcrumbs .id{color:var(--anj-neutral)}"]
                }] }
    ];
    /** @nocollapse */
    ApiDocComponent.ctorParameters = function () { return [
        { type: Title },
        { type: ActivatedRoute },
        { type: undefined, decorators: [{ type: Inject, args: [LIBRARY_API,] }] }
    ]; };
    return ApiDocComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ApiListComponent = /** @class */ (function () {
    function ApiListComponent(api) {
        this.api = api;
        this.filtered = this.api;
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    ApiListComponent.prototype.filter = /**
     * @param {?} __0
     * @return {?}
     */
    function (_a) {
        var _this = this;
        var detail = _a.detail;
        /** @type {?} */
        var query = detail.value.toLowerCase();
        /** @type {?} */
        var filtered = {};
        for (var module in this.api) {
            if (this.api.hasOwnProperty(module)) {
                /** @type {?} */
                var mFiltered = this.api[module].filter(function (d) { return _this.nameFromDoc(d).toLowerCase().includes(query); });
                if (mFiltered.length > 0) {
                    filtered[module] = mFiltered;
                }
            }
        }
        this.filtered = Object.keys(filtered).length > 0 ? filtered : undefined;
    };
    /**
     * @param {?} module
     * @param {?} doc
     * @return {?}
     */
    ApiListComponent.prototype.apiPath = /**
     * @param {?} module
     * @param {?} doc
     * @return {?}
     */
    function (module, doc) {
        return module + "/" + this.nameFromDoc(doc);
    };
    /**
     * @param {?} doc
     * @return {?}
     */
    ApiListComponent.prototype.nameFromDoc = /**
     * @param {?} doc
     * @return {?}
     */
    function (doc) {
        return doc.tag ? doc.tag : doc.name;
    };
    ApiListComponent.decorators = [
        { type: Component, args: [{
                    template: "<anj-form-group>\n    <anj-filter placeholder=\"Search\" (anjFilter)=\"filter($event)\"></anj-filter>\n</anj-form-group>\n<ng-container *ngIf=\"filtered; else noResults\">\n    <section *ngFor=\"let lib of filtered | keyvalue\">\n        <anj-headline><h3>{{lib.key}}</h3></anj-headline>\n        <div class=\"row results-container\">\n            <div *ngFor=\"let doc of lib.value\" class=\"col-12 col-sm-6 col-md-4 col-lg-3 result\">\n                <a [routerLink]=\"apiPath(lib.key, doc)\">{{nameFromDoc(doc)}}</a>\n            </div>\n        </div>\n    </section>\n</ng-container>\n<ng-template #noResults>\n    <p>No matches found.</p>\n</ng-template>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:block}:host anj-headline{border-bottom:1px solid var(--anj-border);padding-bottom:.75rem;margin-bottom:1rem}:host .results-container{margin-bottom:2rem}:host .result{margin-bottom:.5rem}"]
                }] }
    ];
    /** @nocollapse */
    ApiListComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [LIBRARY_API,] }] }
    ]; };
    return ApiListComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ExternalDocComponent = /** @class */ (function () {
    function ExternalDocComponent(docs, route) {
        var _this = this;
        this.docs = docs;
        this.route = route;
        this.doc$ = this.route.paramMap.pipe(switchMap(function (params) { return of(_this.docs[params.get('id')]); }));
    }
    ExternalDocComponent.decorators = [
        { type: Component, args: [{
                    template: '<ad-markdown [data]="doc$ | async"></ad-markdown>',
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    ExternalDocComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [MODULE_DOCS,] }] },
        { type: ActivatedRoute }
    ]; };
    return ExternalDocComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ExternalModuleComponent = /** @class */ (function () {
    function ExternalModuleComponent(docs, name, service) {
        this.docs = docs;
        this.name = name;
        this.service = service;
        /** @type {?} */
        var path = name.toLowerCase();
        this.service.menuItems = Object.keys(docs).map(function (doc) {
            return {
                link: path + "/" + doc,
                name: doc.split('-').join(' ')
            };
        });
    }
    ExternalModuleComponent.decorators = [
        { type: Component, args: [{
                    template: '<router-outlet></router-outlet>',
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    ExternalModuleComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [MODULE_DOCS,] }] },
        { type: String, decorators: [{ type: Inject, args: [MODULE_NAME,] }] },
        { type: DocsService }
    ]; };
    return ExternalModuleComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureComponent = /** @class */ (function () {
    function FeatureComponent(route, changeRef, title, docs, frameWorkType) {
        var _this = this;
        this.route = route;
        this.changeRef = changeRef;
        this.title = title;
        this.docs = docs;
        this.frameWorkType = frameWorkType;
        this.route.params.subscribe(function (params) {
            /** @type {?} */
            var doc = _this.docs.find(function (d) {
                return d.tag ? d.tag === params.id : d.name === params.id;
            });
            _this.doc = _this.filterExamples(doc);
            _this.title.setTitle(_this.titleFromDoc(_this.title.getTitle()));
            _this.changeRef.markForCheck();
        });
    }
    /**
     * @param {?} usages
     * @return {?}
     */
    FeatureComponent.prototype.sortedKeys = /**
     * @param {?} usages
     * @return {?}
     */
    function (usages) {
        /** @type {?} */
        var keys = Object.keys(usages);
        /** @type {?} */
        var firstIndex = keys.findIndex(function (k) { return k === 'usage' || k === 'angular'; });
        return keys.splice(firstIndex, 1).concat(keys);
    };
    /**
     * @private
     * @param {?} title
     * @return {?}
     */
    FeatureComponent.prototype.titleFromDoc = /**
     * @private
     * @param {?} title
     * @return {?}
     */
    function (title) {
        /** @type {?} */
        var base = baseTitle(title);
        if (!this.doc) {
            return base;
        }
        return base + " | " + (this.doc.tag ? titleFromTag(this.doc.tag) : titleFromName(this.doc.name));
    };
    /**
     * @private
     * @param {?} doc
     * @return {?}
     */
    FeatureComponent.prototype.filterExamples = /**
     * @private
     * @param {?} doc
     * @return {?}
     */
    function (doc) {
        /** @type {?} */
        var usages = {};
        if (this.frameWorkType === FrameworkType.angular && doc.usage.angular) {
            for (var u in doc.usage) {
                if (u === 'angular' || u.startsWith('ng-')) {
                    usages[u] = doc.usage[u];
                }
            }
            doc.usage = usages;
        }
        else if (this.frameWorkType === FrameworkType.javascript) {
            for (var u in doc.usage) {
                if (u !== 'angular' && !u.startsWith('ng-')) {
                    usages[u] = doc.usage[u];
                }
            }
            doc.usage = usages;
        }
        return doc;
    };
    FeatureComponent.decorators = [
        { type: Component, args: [{
                    template: "<div class=\"row\">\n    <div [ngClass]=\"doc.usage ? 'col-12 col-lg-10' : 'col-12'\">\n        <article class=\"component-readme\" id=\"overview\">\n            <ad-markdown [data]=\"doc.readme\"></ad-markdown>\n        </article>\n        <article *ngFor=\"let key of sortedKeys(doc.usage)\" id=\"{{key}}\">\n            <ad-use-case [usage]=\"doc.usage[key]\"></ad-use-case>\n        </article>\n        <ad-api [doc]=\"doc\"></ad-api>\n    </div>\n    <div *ngIf=\"doc.usage\" class=\"d-none d-lg-flex col-lg-2 toc-wrapper\">\n        <ad-toc [docs]=\"doc.usage\" [keys]=\"sortedKeys(doc.usage)\"></ad-toc>\n    </div>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".component-readme{margin-bottom:2.5rem}"]
                }] }
    ];
    /** @nocollapse */
    FeatureComponent.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: ChangeDetectorRef },
        { type: Title },
        { type: Array, decorators: [{ type: Inject, args: [MODULE_DOCS,] }] },
        { type: FrameworkType, decorators: [{ type: Optional }, { type: Inject, args: [MODULE_TYPE,] }] }
    ]; };
    return FeatureComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var HomeComponent = /** @class */ (function () {
    function HomeComponent(title, service, getStartedUrl, readme) {
        this.title = title;
        this.service = service;
        this.getStartedUrl = getStartedUrl;
        this.readme = readme;
        this.service.menuItems = null;
        this.title.setTitle(baseTitle(this.title.getTitle()));
    }
    HomeComponent.decorators = [
        { type: Component, args: [{
                    template: "<article>\n    <ad-markdown [data]=\"readme\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <anj-button [routerLink]=\"getStartedUrl\" size=\"large\">Get Started</anj-button>\n    </p>\n</article>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    HomeComponent.ctorParameters = function () { return [
        { type: Title },
        { type: DocsService },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [GET_STARTED_URL,] }] },
        { type: String, decorators: [{ type: Inject, args: [HOME_README,] }] }
    ]; };
    return HomeComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IntroComponent = /** @class */ (function () {
    function IntroComponent(title, readme, moduleName, getStartedUrl) {
        this.title = title;
        this.readme = readme;
        this.moduleName = moduleName;
        this.getStartedUrl = getStartedUrl;
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + moduleName);
    }
    IntroComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ad-components',
                    template: "<article>\n    <ad-markdown [data]=\"readme\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <anj-button [routerLink]=\"getStartedUrl\" size=\"large\">Try It</anj-button>\n    </p>\n</article>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [":host::ng-deep ad-markdown p[align=center]{display:none}"]
                }] }
    ];
    /** @nocollapse */
    IntroComponent.ctorParameters = function () { return [
        { type: Title },
        { type: String, decorators: [{ type: Inject, args: [MODULE_README,] }] },
        { type: String, decorators: [{ type: Inject, args: [MODULE_NAME,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [MODULE_GET_STARTED_URL,] }] }
    ]; };
    return IntroComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
JsDemo = /** @class */ (function () {
    function JsDemo(element, demo) {
        element.nativeElement.appendChild(document.createRange().createContextualFragment(demo));
    }
    return JsDemo;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UseCaseComponent = /** @class */ (function () {
    function UseCaseComponent(sanitizer) {
        this.sanitizer = sanitizer;
    }
    /**
     * @return {?}
     */
    UseCaseComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var docs = this.usage.split('<!-- Demo -->');
        this.doc = docs[0].trim();
        this.demo = docs[1] ? this.sanitizer.bypassSecurityTrustHtml(docs[1] ? docs[1].trim() : '') : undefined;
        if (docs[2]) {
            /** @type {?} */
            var tabs_1 = {};
            docs[2].trim().split('```').forEach(function (s) {
                s = s.trim();
                if (s) {
                    tabs_1[s.split(/\n/)[0].trim()] = "" + '```' + s + '```';
                }
            });
            this.tabs = tabs_1;
        }
    };
    /**
     * @param {?=} tab
     * @return {?}
     */
    UseCaseComponent.prototype.switchTabs = /**
     * @param {?=} tab
     * @return {?}
     */
    function (tab) {
        this.activeTab = tab ? tab : this.activeTab ? undefined : Object.keys(this.tabs)[0];
    };
    /**
     * @param {?} doc
     * @return {?}
     */
    UseCaseComponent.prototype.getTitle = /**
     * @param {?} doc
     * @return {?}
     */
    function (doc) {
        return doc.split('\n')[0].replace(/#/g, '').trim();
    };
    /**
     * @param {?} type
     * @return {?}
     */
    UseCaseComponent.prototype.codeType = /**
     * @param {?} type
     * @return {?}
     */
    function (type) {
        return type.includes('typescript') ? 'ts' : type;
    };
    UseCaseComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ad-use-case',
                    template: "<ad-markdown [data]=\"doc\"></ad-markdown>\n<anj-card *ngIf=\"demo\">\n    <anj-card-header>\n        <anj-headline>\n            <h3>{{getTitle(doc)}}</h3>\n            <anj-button context=\"icon\" (click)=\"switchTabs()\" title=\"View Source\"><i class=\"z-icon-file-code\"></i></anj-button>\n        </anj-headline>\n    </anj-card-header>\n    <anj-card-body>\n        <div class=\"example-container\" [class.anj-active]=\"activeTab\">\n            <anj-tabs>\n                <anj-tab *ngFor=\"let t of tabs | keyvalue\" (click)=\"switchTabs(t.key)\" [class.anj-active]=\"t.key === activeTab\">{{codeType(t.key)}}</anj-tab>\n            </anj-tabs>\n            <div class=\"example\">\n                <ad-markdown *ngFor=\"let t of tabs | keyvalue\" [data]=\"t.value\" [class.anj-active]=\"t.key === activeTab\"></ad-markdown>\n            </div>\n        </div>\n        <div *ngIf=\"demo\" class=\"demo-container\" [innerHTML]=\"demo\"></div>\n    </anj-card-body>\n</anj-card>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [":host{border-bottom:1px solid var(--anj-border);display:block;margin-bottom:3rem;padding-bottom:3.5rem}:host anj-card{margin-top:2rem}:host anj-tab{text-transform:uppercase}:host .example-container{margin:0 -1.25rem}:host .example-container:not(.anj-active){height:0;overflow:hidden}:host .example{background-color:var(--anj-background);border-bottom:1px solid var(--anj-border);margin:0 0 1rem;padding:1rem}:host .example ad-markdown{display:none}:host .example ad-markdown.anj-active{display:block}"]
                }] }
    ];
    /** @nocollapse */
    UseCaseComponent.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    UseCaseComponent.propDecorators = {
        usage: [{ type: Input }]
    };
    return UseCaseComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AnjunaDocsModule = /** @class */ (function () {
    function AnjunaDocsModule() {
    }
    AnjunaDocsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        RouterModule
                    ],
                    declarations: [
                        ApiComponent,
                        ApiDocComponent,
                        ApiListComponent,
                        ExternalDocComponent,
                        ExternalModuleComponent,
                        FeatureComponent,
                        IntroComponent,
                        UseCaseComponent,
                        HomeComponent
                    ],
                    exports: [
                        ApiComponent,
                        ApiDocComponent,
                        ApiListComponent,
                        ExternalDocComponent,
                        ExternalModuleComponent,
                        FeatureComponent,
                        IntroComponent,
                        HomeComponent
                    ],
                    entryComponents: [
                        ApiComponent,
                        ApiDocComponent,
                        ApiListComponent,
                        FeatureComponent,
                        IntroComponent,
                        HomeComponent
                    ],
                    schemas: [
                        CUSTOM_ELEMENTS_SCHEMA
                    ]
                },] }
    ];
    return AnjunaDocsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ApiComponent, ApiDocComponent, ApiListComponent, ExternalDocComponent, ExternalModuleComponent, FeatureComponent, HomeComponent, IntroComponent, FrameworkType, DEMO_COMPONENTS, GET_STARTED_URL, HOME_README, LIBRARY_API, MODULE_DOCS, MODULE_GET_STARTED_URL, MODULE_NAME, MODULE_README, MODULE_TYPE, DocsService, baseTitle, titleFromName, titleFromTag, JsDemo, AnjunaDocsModule, UseCaseComponent as ɵa };

//# sourceMappingURL=anjuna-angular-docs.js.map